package es.carlosgarcia;

import java.util.ArrayList;
import java.util.Date;

import android.app.Activity;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;

/**
 * Ventana de test del ContentProvider
 * @author Carlos García. 
 * @see http://www.carlos-garcia.es
 */
public class GmailContentProviderActivity extends Activity implements OnClickListener, IBackgroudTaskResultListener {
   
	private Button   btnReadGmail;
	private EditText txtGmailContent;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        this.configureUI();
    }
    
    private void configureUI(){
        this.setContentView(R.layout.main);
        this.txtGmailContent = (EditText) this.findViewById(R.id.txtEmails);
        this.btnReadGmail = (Button) this.findViewById(R.id.cmdReadMails);
        this.btnReadGmail.setOnClickListener(this);    	
    }
    
	@Override
	public void onClick(View v) {
		txtGmailContent.setText("");
		
		if (btnReadGmail == v){
			String account  = "cgpcosmad@gmail.com";
			Date   fromDate = new Date(2011, 7, 1);
			
			GmailReadTask task = new GmailReadTask(this.getContentResolver(), this, account, fromDate); 
			task.execute();
		}
	}
	
	
	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		if (keyCode == KeyEvent.KEYCODE_BACK) {
			this.finish();
			return true;
		}
		return super.onKeyDown(keyCode, event);
	}

	private void paintMessages(ArrayList<Mail> emails){
		if (emails != null){
			for (Mail mail : emails){
				txtGmailContent.append(mail.getSubject());
				txtGmailContent.append("\n---\n");
			}
		} else {
			txtGmailContent.append("No hay emails");
		}
	}

	@SuppressWarnings("unchecked")
	@Override
	public void backgroundTaskFinished(String code, Object result) {
		if ("ok".equals(code)){
			this.paintMessages((ArrayList<Mail>) result);
		}
	}
}